/*
 * Copyright (C) 2013 John Graham <johngavingraham@googlemail.com>.
 *
 * This file is part of Pthread Pool.
 *
 * Pthread Pool is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of the
 * License, or (at your option) any later version.
 *
 * Pthread Pool is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Pthread Pool.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <pthread_pool.h>

#include <errno.h>

#include <test.h>

pthread_pool_t        pool;
pthread_pool_worker_t worker;
pthread_pool_task_t   task;

/*
 * Task that waits on the pool it's in.
 */
void *task_function(void *arg)
{
  /* If we return the correct exit code here, the test was a
   * success. */
  assert_equal(EDEADLK, pthread_pool_join(&pool, NULL));
  exit(0);
  return arg;
}

int main(void)
{
  /* Set a pool going with one thread to run one task. */
  assert_equal(0, pthread_pool_create(&pool, NULL));
  assert_equal(0, pthread_pool_worker_init(&worker, &pool, NULL));
  assert_equal(0, pthread_pool_task_init(&task, &pool, &task_function,
					 NULL));

  /* Loop forever - success depends on getting to the end of
   * task_function. */
  while (1)
    /* Nop. */;
}
