/*
 * Copyright (C) 2013 John Graham <johngavingraham@googlemail.com>.
 *
 * This file is part of Pthread Pool.
 *
 * Pthread Pool is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of the
 * License, or (at your option) any later version.
 *
 * Pthread Pool is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Pthread Pool.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef TEST_H
#define TEST_H

#include <stdio.h>
#include <stdlib.h>

/* Make sure assert() is the debug version (this also means we have
 * to #include this last). */
#ifdef  NDEBUG
# undef NDEBUG
#endif
#include <assert.h>

#define assert_equal(EXPECTED, ACTUAL)                 \
  do {                                                 \
    if ((EXPECTED) != (ACTUAL)) {                      \
      fprintf(stderr, "%s:%d: Expected %d, got %d\n",  \
      __FILE__, __LINE__, (EXPECTED), (ACTUAL));       \
      abort();                                         \
    }                                                  \
  } while (0)

#endif /* TEST_H */


























